package svc

import (
	"app-cloudep-order-server/internal/config"
	model "app-cloudep-order-server/internal/model/mongo"

	ers "code.30cm.net/digimon/library-go/errs"
	"code.30cm.net/digimon/library-go/errs/code"
	vi "code.30cm.net/digimon/library-go/validator"
)

type ServiceContext struct {
	Config   config.Config
	Validate vi.Validate

	OrderModel model.OrderModel
}

func NewServiceContext(c config.Config) *ServiceContext {
	ers.Scope = code.CloudEPOrder

	return &ServiceContext{
		Config:     c,
		Validate:   vi.MustValidator(WithDecimalGt(), WithDecimalGte()),
		OrderModel: MustOrderModel(c),
	}
}
